#ifndef __AMSCLIL1_GUTMANNPRNG_H__
#define __AMSCLIL1_GUTMANNPRNG_H__

typedef struct amsclil1_gprng_state
{
    int randpool_length;
    uint8_t *randpool;
    int write_pointer;
    int cycle_pointer;

} amsclil1_gprng_state;

int amsclil1_gprng_state_new(amsclil1_gprng_state **s);
void amsclil1_gprng_state_delete(amsclil1_gprng_state **s);

//sets new random pool length (default is 640 bytes)
int amsclil1_gprng_state_resize(amsclil1_gprng_state *s, int N);

void amsclil1_gprng_add_byte(amsclil1_gprng_state *s, uint8_t byte);
void amsclil1_gprng_add_bytes(amsclil1_gprng_state *s, uint8_t *bytes, int N);

void amsclil1_gprng_mix_once(amsclil1_gprng_state *s);
void amsclil1_gprng_mix(amsclil1_gprng_state *s);

//Original gprng hash is MD5, set to take 84 bytes in, and provide 16 bytes out
void amsclil1_gprng_hash(uint8_t *bytes_in, int Nin, uint8_t *bytes_out);

//: A randompool of 640 bytes (5120 bits) and a hash algorithm 
// outputing 16 bytes (128) bits, requires 40 cycles, not 30, to
// completely cover the random pool.


#endif