#include <amsclil1/amsclil1.h>

void test_addsub()
{
    long N = 2;
    uint32_t a[N],b[N],c[N];

    printf("amsclil1: Test addition and subtraction.\n");
    

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x01;
    b[0] = 0x01;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a+b=c\n");
    amsclil1_fb32_add(a,b,c,N);
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xffffffff;
    b[0] = 0x10000000;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a+b=c\n");
    amsclil1_fb32_add(a,b,c,N);
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xffffffff; a[1] = 0xf0;
    b[0] = 0x01000000; b[1] = 0x01;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a+b=c\n");
    amsclil1_fb32_add(a,b,c,N);
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xffffffff; a[1] = 0xffffffff;
    b[0] = 0xffffffff; b[1] = 0xffffffff;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a+b=c\n");
    amsclil1_fb32_add(a,b,c,N);
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x01;
    b[0] = 0x01;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a-b=c\n");
    amsclil1_fb32_sub(a,b,c,N);
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xf0;
    b[0] = 0x01;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a-b=c\n");
    amsclil1_fb32_sub(a,b,c,N);
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x01;
    b[0] = 0xf0;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a-b=c\n");
    amsclil1_fb32_sub(a,b,c,N);
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x0fffffff; a[1] = 0xffffffff;
    b[0] = 0x30000000; b[1] = 0x00000000;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a+b=c\n");
    amsclil1_fb32_sub(a,b,c,N);
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");
    
    
    return;
}

void test_mult()
{
    long N = 2;
    uint32_t a[N],b[N],c[2*N];
    uint32_t wrk[6*N];

    printf("amsclil1: Test multiplication.\n");
    
    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xffffffff; a[1] = 0x00000000;
    b[0] = 0xffffffff; b[1] = 0x00000000;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a*b=c\n");
    amsclil1_fb32_mult(a,b,c,wrk,N);
    printf("c="); amsclil1_fb32_liprint(c,2*N); printf("\n");


    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x0fffffff; a[1] = 0xffffffff;
    b[0] = 0x30000000; b[1] = 0x00000000;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a*b=c\n");
    amsclil1_fb32_mult(a,b,c,wrk,N);
    printf("c="); amsclil1_fb32_liprint(c,2*N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xffffffff; a[1] = 0xffffffff;
    b[0] = 0xffffffff; b[1] = 0xffffffff;
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a*b=c\n");
    amsclil1_fb32_mult(a,b,c,wrk,N);
    printf("c="); amsclil1_fb32_liprint(c,2*N); printf("\n");

    
    return;
}

void test_div()
{
    long N = 2;
    uint32_t a[N],b[N],c[N],d[N];
    //uint32_t wrk[3*(N+1)];
    uint32_t wrk[5*(N+1)];
    printf("amsclil1: Test division.\n");
    
    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xffffaf0f; a[1] = 0x00000000;
    b[0] = 0x00000001; b[1] = 0x00000000;
    printf("a  ="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b  ="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a/b=res,rem\n");
    amsclil1_fb32_div(a,b,c,d,wrk,N);
    printf("res="); amsclil1_fb32_liprint(c,N); printf("\n");
    printf("rem="); amsclil1_fb32_liprint(d,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xffffaf0f; a[1] = 0x00000000;
    b[0] = 0x00000100; b[1] = 0x00000000;
    printf("a  ="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b  ="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a/b=res,rem\n");
    amsclil1_fb32_div(a,b,c,d,wrk,N);
    printf("res="); amsclil1_fb32_liprint(c,N); printf("\n");
    printf("rem="); amsclil1_fb32_liprint(d,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0xffffaf0f; a[1] = 0x00000000;
    b[0] = 0xf0000000; b[1] = 0x00000000;
    printf("a  ="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b  ="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a/b=res,rem\n");
    amsclil1_fb32_div(a,b,c,d,wrk,N);
    printf("res="); amsclil1_fb32_liprint(c,N); printf("\n");
    printf("rem="); amsclil1_fb32_liprint(d,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x00000001; a[1] = 0x00000000;
    b[0] = 0xf0000000; b[1] = 0x00000000;
    printf("a  ="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b  ="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a/b=res,rem\n");
    amsclil1_fb32_div(a,b,c,d,wrk,N);
    printf("res="); amsclil1_fb32_liprint(c,N); printf("\n");
    printf("rem="); amsclil1_fb32_liprint(d,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x00000001; a[1] = 0x00000000;
    b[0] = 0x00000000; b[1] = 0x00000000;
    printf("a  ="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b  ="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a/b=res,rem\n");
    amsclil1_fb32_div(a,b,c,d,wrk,N);
    printf("res="); amsclil1_fb32_liprint(c,N); printf("\n");
    printf("rem="); amsclil1_fb32_liprint(d,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x00000004; a[1] = 0xff0ff0ff;
    b[0] = 0x00000004; b[1] = 0x00000000;
    printf("a  ="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b  ="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a/b=res,rem\n");
    amsclil1_fb32_div(a,b,c,d,wrk,N);
    printf("res="); amsclil1_fb32_liprint(c,N); printf("\n");
    printf("rem="); amsclil1_fb32_liprint(d,N); printf("\n");

    printf("\n");
    amsc_ui32_memset(a,0,2);
    amsc_ui32_memset(b,0,2);
    amsc_ui32_memset(c,0,2);
    a[0] = 0x00000001; a[1] = 0x00000000;
    b[0] = 0x00000000; b[1] = 0x00000000;
    printf("a  ="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b  ="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("a/b=res,rem\n");
    amsclil1_fb32_div(a,b,c,d,wrk,N);
    printf("res="); amsclil1_fb32_liprint(c,N); printf("\n");
    printf("rem="); amsclil1_fb32_liprint(d,N); printf("\n");
    
    return;
}

void test_modpower()
{
    long N = 2;
    uint32_t a[N],b[N],c[N],d[N];
    uint32_t wrk[8*(N+2)];
    uint32_t stor[12*(N+1)];

    printf("amsclil1: Mod power tests.\n");

    printf("\n");
    amsc_ui32_memset(a,0,N);
    amsc_ui32_memset(b,0,N);
    amsc_ui32_memset(c,0,N);
    amsc_ui32_memset(d,0,N);
    a[0] = 0x00000010; a[1] = 0x00000000;
    b[0] = 0x00000002; b[1] = 0x00000000;
    c[0] = 0x000000ff; c[1] = 0x00000000;
    printf("mod(a^b, c) = d\n");
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");
    amsclil1_fb32_modpower(a,b,c,d,wrk,stor,N);
    printf("d="); amsclil1_fb32_liprint(d,N); printf("\n"); //0x01 - check

    printf("\n");
    amsc_ui32_memset(a,0,N);
    amsc_ui32_memset(b,0,N);
    amsc_ui32_memset(c,0,N);
    amsc_ui32_memset(d,0,N);
    a[0] = 0x0000faf0; a[1] = 0x00000000;
    b[0] = 0x00000c0a; b[1] = 0x00000000;
    c[0] = 0x00ffaaff; c[1] = 0x00000000;
    printf("mod(a^b, c) = d\n");
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");
    amsclil1_fb32_modpower(a,b,c,d,wrk,stor,N);
    printf("d="); amsclil1_fb32_liprint(d,N); printf("\n"); //0xf5ee89 - check
    
    printf("\n");
    amsc_ui32_memset(a,0,N);
    amsc_ui32_memset(b,0,N);
    amsc_ui32_memset(c,0,N);
    amsc_ui32_memset(d,0,N);
    a[0] = 0x0000afaf; a[1] = 0xafaf0000;
    b[0] = 0xff00ff00; b[1] = 0xff00ff00;
    c[0] = 0x10101010; c[1] = 0x10101010;
    printf("mod(a^b, c) = d\n");
    printf("a="); amsclil1_fb32_liprint(a,N); printf("\n");
    printf("b="); amsclil1_fb32_liprint(b,N); printf("\n");
    printf("c="); amsclil1_fb32_liprint(c,N); printf("\n");
    amsclil1_fb32_modpower(a,b,c,d,wrk,stor,N);
    printf("d="); amsclil1_fb32_liprint(d,N); printf("\n"); //0x6e10c57c1e7bc71 - check
    

    //speed test - moment of truth: can you do 4096 bit (64) RSA?
    long N2 = 64;
    uint32_t a2[N2],b2[N2],c2[N2],d2[N2];
    uint32_t wrk2[8*(N2+2)];
    uint32_t stor2[12*(N2+1)];

    printf("\n");
    amsc_ui32_memset(a2,0,N2);
    amsc_ui32_memset(b2,0,N2);
    amsc_ui32_memset(c2,0,N2);
    amsc_ui32_memset(d2,0,N2);
    a2[0] = 0x00000077; a2[N2-1] = 0x70000000;
    b2[0] = 0x00000066; b2[N2-1] = 0xff000000;
    c2[0] = 0x00000013; c2[N2-1] = 0x13000000;
    printf("mod(a^b, c) = d\n");
    printf("a2="); amsclil1_fb32_liprint(a2,N2); printf("\n");
    printf("b2="); amsclil1_fb32_liprint(b2,N2); printf("\n");
    printf("c2="); amsclil1_fb32_liprint(c2,N2); printf("\n");
    amsclil1_fb32_modpower(a2,b2,c2,d2,wrk2,stor2,N2);
    printf("d2="); amsclil1_fb32_liprint(d2,N2); printf("\n"); 
    //still takes too blasted long
        
    return;
}